#include <iostream>
#include <array>

void print_arr(const auto& arr) {
	std::cout << "{ ";
	bool first = true;
	for (auto& elem : arr) {
		if (first) {
			first = false;
		} else {
			std::cout << ", ";
		}
		std::cout << elem;
	}
	std::cout << " }\n";
}

int main() {
	std::array<int, 7> arr1;
	// print_arr(arr1); // uninitialized
	for (int i = 0; int& elem : arr1) {
		elem = ++i;
	}

	print_arr(arr1);

	std::array<int, 7> arr2 = { 42, 17 };
	print_arr(arr2);

	std::array<int, 5> arr3 = {};
	print_arr(arr3);

	std::array arr4 = { 3.14, 5.0, 7.12, 42.17 };
	print_arr(arr4);

	// try using reference
	auto arr5 = arr3;
	arr3[1] = 7;
	arr5[1] = 12;
	print_arr(arr3);
	print_arr(arr5);

	arr2 = arr1;  // copy – needs the same type and size!
	arr2[0] = 100;
	print_arr(arr1);
	print_arr(arr2);

	// try with reference
	auto [a, b, c, d] = arr4;
	std::cout << a << '\n';
	b = -1.0;
	print_arr(arr4);
}
