#include <iostream>

void print(auto x) {
	std::cout << x << '\n';
}

struct point {
	double x, y;
	int colour = -1;
};

int main() {
	point p1;
	// print(p1.x);  // uninitialized
	p1.x = 1.0;
	p1.y = 3.14;
	p1.colour = 7;

	print(p1.x);

	point p2 = { 2.2, 5.3, 11 };

	print(p2.x);
	print(p2.colour);

	point p3 = { .x = 2.2, .y = 3.14 };

	print(p3.y);
	print(p3.colour);

	point p4 = {};

	print(p4.x);  // zero-initialized
	print(p4.colour);

	point p5 = p1;  // copy
	p5.x = 12.34;
	print(p5.x);
	print(p1.x);

	p5 = p3;  // copy
	p3.x = 42.17;
	print(p5.x);
	print(p3.x);

	// try with reference
	auto [x, y, c] = p1;
	p1.colour = 99;
	print(c);
	print(p1.colour);
}
