#include <iostream>
#include <map>
#include <ranges>

void print_map(const auto& m) {
	for (auto& [k, v]: m) {
		std::cout << k << ": " << v << '\n';
	}
	std::cout << "---\n";
}

int main() {
	std::multimap<char, int> m = {
		{ 'x', 1 },
		{ 'z', 2 },
		{ 'x', 7 },
		{ 'z', 0 },
		{ 'a', 3 },
		{ 'z', 5 },
		{ 'a', 3 },
	};

	print_map(m);

	for (auto [from, to] = m.equal_range('x');
			auto& [k, v] :
				std::ranges::subrange{ from, to }) {
		v += 10;
	}

	print_map(m);
}
