#include <array>
#include <cassert>
#include <iostream>
#include <tuple>

struct point {
	int x, y;
};

void print_point(point p) {
	std::cout << "(" << p.x << ", " << p.y << ")\n";
}

void print_triple(const auto& t) {
	auto& [a, b, c] = t;
	std::cout << "(" << a << ", " << b << ", " << c << ")\n";
}

void print_array(const auto& arr) {
	std::string sep = "{ ";
	for (auto& elem : arr) {
		std::cout << sep << elem;
		sep = ", ";
	}
	std::cout << " }\n";
}

std::tuple<bool, int, double> get_triple() {
	return { false, 0, 0.0 };
}

auto get_triple1() {
	return std::tuple{ true, 1, 1.0 };
}

point add_points(point a, point b) {
	return { a.x + b.x, a.y + b.y };
}

int main() {
	print_point(point{ 1, 2 });
	print_point({ 3, 4 });
	print_point(add_points({ 5, 6 }, { 7, 8 }));

	// cannot omit std::tuple here
	print_triple(std::tuple{ true, 3.14, 'x' });

	auto t = get_triple();
	print_triple(t);
	// extra parentheses are necessary here
	assert((t == std::tuple{ false, 0, 0.0 }));

	// cannot omit std::array here
	print_array(std::array{ 42, 17, 314, 256 });
}
