#include <iostream>
#include <tuple>
#include <utility>

void print(auto x) {
	std::cout << x << '\n';
}

int main() {
	std::tuple<bool, int, double> triple;
	print(std::get<2>(triple));

	std::get<0>(triple) = true;
	std::get<1>(triple) = 42;
	std::get<2>(triple) = 3.14;

	/* with initialisation: */
	// std::tuple<bool, int, double> triple = { true, 42, 3.14 };
	/* with type deduction: */
	// std::tuple triple = { true, 42, 3.14 };

	print(std::get<1>(triple));

	std::pair<bool, int> p;
	p.first = false;
	p.second = 17;

	// std::pair<bool, int> p = { false, 17 };
	// std::pair p = { false, 17 };

	print(std::get<0>(p));

	std::tuple<bool, int, double> clone = triple;
	// better: std::tuple clone = triple;
	// even better: auto clone = triple;

	std::get<1>(clone) = 23;
	print(std::get<1>(clone));
	print(std::get<1>(triple));

	clone = triple;
	print(std::get<1>(clone));

	/* std::tie */
	bool bb;
	int ii;

	std::tie(bb, ii) = p;
	/* same as: bb = p.first; ii = p.second; */

	print(ii);

	/* structured binding */
	auto [b, i, d] = triple;        // copy
	// auto& [b, i, d] = triple;       // reference
	// const auto& [b, i, d] = triple; // const reference

	i = 1;
	print(d);
	print(std::get<1>(triple));
}
