#include <iostream>
#include <vector>

void print_vec(const auto& vec) {
	std::cout << "vector of size " << vec.size() << ":";
	for (auto& elem : vec) {
		std::cout << ' ' << elem;
	}
	std::cout << '\n';
}

int main() {
	std::vector<int> v; // no ‹= {}› needed here
	print_vec(v);

	v.push_back(1);
	v.push_back(2);
	v.push_back(3);
	v.push_back(4);
	v.pop_back();
	v[1] = -1;

	print_vec(v);

	std::vector v1 = { 1, 2, 7, 17, 42 };

	print_vec(v1);

	v1.resize(7); // changing the size of the vector

	print_vec(v1);

	auto v2 = v1; // copy; try changing to reference

	v1.back() = 100;
	v2.front() = -7;
	print_vec(v1);
	print_vec(v2);
}
