#include <iostream>
#include <vector>

struct point {
	int x, y;
};

void print_vp(const std::vector<point>& vec) {
	std::cout << "vector of size " << vec.size() << ":";
	for (point p : vec) {
		std::cout << " (" << p.x << ", " << p.y << ")";
	}
	std::cout << '\n';
}

int main() {
	print_vp({ { 0, 0 }, { 1, 1 } });

	std::vector<point> vp = { { 1, 0 }, { 2, 3 }, { 7, -1 } };
	print_vp(vp);

	vp.push_back(point{ 1, 1 });
	// better:
	vp.push_back({ 2, 2 });
	// even better:
	vp.emplace_back(3, 3);

	print_vp(vp);
}
